/*
Антон (Лилой) Москаленко
e-mail: liloi@mail.ru

Вот, решил написать матрицу :-) Теперь Вам не надо морочиться
создавая динамический массив.

    l_matrix mat(i,j);
    i -  количество строк
    j -  количество стобиков

    mat.putn(i,j,num) -  поместить num в ij элемент. Можно по другому:
    mat.matrix[i][j] = num; Только если i  и  j  превысят те, которые
Вы указывали при инициализации - ошибки не избежать.

    float a = mat.getn(i,j) - "достать" число из ij-го элемента. Иначе:
    float a = mat.matrix[i][j]; Об ошибке я уже говорил.

    int i = mat.geti(); - получить i
    int j = mat.getj(); - получить j

Почему нельзя так: int i = mat.i? Поясняю: матрица и i или j связаны.
А если Вам захочется изменить i без изменения матрицы?

Другие функции можно юзать так:
    float d = det_mat(mat.matrix, mat.geti());
*/

#ifndef MAT_INIT
#define MAT_INIT

#include <iostream.h>

class l_matrix
{
    public:
        float **matrix;
        
        l_matrix(int,int);
        ~l_matrix();
        
        void putn(int,int,float);
        float getn(int, int);
        
        int get_i();
        int get_j();
    
    protected:
        int i, j;
};

    l_matrix::l_matrix(int i, int j)
    {
        l_matrix::matrix = new float*[i];
        for(int a=0;a<i;a++) l_matrix::matrix[a] = new float[j];
        l_matrix::i = i;
        l_matrix::j = j;
    }
    
    l_matrix::~l_matrix()
    {
        for(int a=0;a<l_matrix::i;a++) delete[]l_matrix::matrix[a];
        delete[]l_matrix::matrix;
    }
    
    void l_matrix::putn(int i, int j, float num)
    {
    
        if((i>=l_matrix::i)||(j>=l_matrix::j))
        {
            cout << "This element does not exists" << endl;     
        }
        else
        l_matrix::matrix[i][j] = num;
    }
    
    float l_matrix::getn(int i, int j)
    {
        if((i>=l_matrix::i)||(j>=l_matrix::j))
        {
            cout << "This element does not exists" << endl;
        }
        else
        return l_matrix::matrix[i][j];    
    }
    
    int l_matrix::get_i()
    {
        return l_matrix::i;
    }
    
    int l_matrix::get_j()
    {
        return l_matrix::j;
    }
    
#endif
 
//

